Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Static Public Attributes

# MopathRecorder Class Reference

Inherits direct::showbase::DirectObject::DirectObject.

List of all members.

## Public Member Functions
def | __init__
def | addKeyframe
def | addNodePath
def | addNodePathToDict
def | addWidget
| WIDGET UTILITY FUNCTIONS ##.
def | appInit
def | computeCurves
def | createAngleDial
def | createButton
def | createCheckbutton
def | createColorEntry
def | createComboBox
def | createEntryScale
def | createFloater
def | createInterface
def | createLabeledEntry
def | createNewPointSet
def | createOptionMenu
def | createRadiobutton
def | createSlider
def | createVector2Entry
def | createVector3Entry
def | cropCurve
def | curveEditTask
def | desampleCurve
def | deselectedNodePathHook
def | disableKeyframeButton
def | easeInOut
def | enableKeyframeButton
def | extractPointSetFromCurveCollection
def | extractPointSetFromCurveFitter
def | faceForward
def | followTerrain
def | getChildIds
def | getPostPoints
def | getPrePoints
def | getVariable
def | getWidget
def | initTrace
def | jumpToEndOfPlayback
def | jumpToStartOfPlayback
def | loadCurveFromFile
def | makeCameraWindow
def | makeEven
def | manipulateObjectCleanupHook
def | manipulateObjectStartHook
def | mergePoints
def | onDestroy
def | playbackGoTo
def | playbackTask
def | pushRedo
def | pushRedoHook
def | pushUndo
def | pushUndoHook
def | recordPoint
def | recordTask
def | redoHook
def | redoListEmptyHook
def | reset
def | sampleCurve
def | saveCurveToFile
def | selectedNodePathHook
def | selectNodePathNamed
def | selectPointSetNamed
def | setControlStart
def | setControlStop
def | setCropFrom
def | setCropTo
def | setCvColor
def | setCvVis
def | setDesampleFrequency
def | setExtendMode
def | setHullColor
def | setHullVis
def | setKeyframeHook
def | setKnotColor
def | setKnotVis
def | setLoopPlayback
def | setMarkerVis
def | setNewCurveMode
def | setNodePath
def | setNumSamples
def | setNumSegs
def | setNumTicks
def | setPathColor
def | setPathDuration
def | setPathDurationTo
def | setPathVis
def | setPlaybackNodePath
def | setPlaybackSF
def | setPreRecordFunc
def | setRecordingType
def | setRecordStart
def | setRefineMode
def | setRefineStop
def | setSamplingMode
def | setSpeedScale
def | setStartStopHook
def | setTickColor
def | setTickScale
def | setTraceVis
def | startPlayback
def | startStopPlayback
def | stopPlayback
def | toggleRecord
def | toggleRecordVar
def | undoHook
def | undoListEmptyHook
def | updateWidgets
## Public Attributes
| actionEvents
| cCam
| cCamera
| cCamNode
| cDr
| cLayer
| cLens
| controlStart
| controlStop
| cropFrom
| cropPage
| cropTo
| curveCollection
| curveFitter
| curveNodePath
| deltaTime
| desampleFrequency
| drawPage
| extendPage
| fAdjustingValues
| hasPoints
| iRay
| iRayCS
| keyframeHook
| lastPos
| layerIndex
| loopPlayback
| mainNotebook
| manipulandumId
| maxT
| name
| nodePath
| nodePathDict
| nodePathMenu
| nodePathMenuBG
| nodePathMenuEntry
| nodePathNames
| nodePathParent
| numSamples
| numSegs
| numTicks
| nurbsCurveDrawer
| oldPlaybackNodePath
| optionsPage
| playbackMarker
| playbackMarkerIds
| playbackNodePath
| playbackSF
| playbackTime
| pointSet
| pointSetCount
| pointSetDict
| pointSetName
| postPoints
| prePoints
| preRecordFunc
| OPTIONS PAGE ##.
| recorderNodePath
| recordingType
| recordStart
| recordStop
| redoButton
| refinePage
| resamplePage
| samplingMode
| sf
| RESAMPLE PAGE.
| speedEntry
| speedScale
| speedVar
| startStopHook
| tangentGroup
| tangentLines
| tangentMarker
| tangentMarkerIds
| tempCS
| trace
| undoButton
| variableDict
| widgetDict
## Static Public Attributes
string | appname = 'Mopath Recorder Panel'
int | count = 0
int | frameHeight = 550
int | frameWidth = 450
int | usecommandarea = 0
int | usestatusarea = 0

## Constructor & Destructor Documentation

def __init__ | ( |  | self,
|  |  | parent = `None`,
|  |  | kw
| ) |  |

## Member Function Documentation

def addKeyframe | ( |  | self,
|  |  | fToggleRecord = `1`
| ) |  |

def addNodePath | ( |  | self,
|  |  | nodePath
| ) |  |

def addNodePathToDict | ( |  | self,
|  |  | nodePath,
|  |  | names,
|  |  | menu,
|  |  | dict
| ) |  |

def addWidget | ( |  | self,
|  |  | widget,
|  |  | category,
|  |  | text
| ) |  |

WIDGET UTILITY FUNCTIONS ##.

def appInit | ( |  | self | ) |

def computeCurves | ( |  | self | ) |

def createAngleDial | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = `None`,
|  |  | kw
| ) |  |

def createButton | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command,
|  |  | side = `'top'`,
|  |  | expand = `0`,
|  |  | fill = `X`
| ) |  |

def createCheckbutton | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command,
|  |  | initialState,
|  |  | side = `'top'`,
|  |  | fill = `X`,
|  |  | expand = `0`
| ) |  |

def createColorEntry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = `None`,
|  |  | kw
| ) |  |

def createComboBox | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | items,
|  |  | command,
|  |  | history = `0`,
|  |  | side = `LEFT`,
|  |  | expand = `0`,
|  |  | fill = `X`
| ) |  |

def createEntryScale | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = `None`,
|  |  | min = `0.0`,
|  |  | max = `1.0`,
|  |  | resolution = `None`,
|  |  | side = `TOP`,
|  |  | fill = `X`,
|  |  | expand = `1`,
|  |  | kw
| ) |  |

def createFloater | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = `None`,
|  |  | min = `0.0`,
|  |  | resolution = `None`,
|  |  | maxVelocity = `10.0`,
|  |  | kw
| ) |  |

def createInterface | ( |  | self | ) |

def createLabeledEntry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | value = `''`,
|  |  | command = `None`,
|  |  | relief = `'sunken'`,
|  |  | side = `LEFT`,
|  |  | expand = `1`,
|  |  | width = `12`
| ) |  |

def createNewPointSet | ( |  | self | ) |

def createOptionMenu | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | items,
|  |  | command
| ) |  |

def createRadiobutton | ( |  | self,
|  |  | parent,
|  |  | side,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | variable,
|  |  | value,
|  |  | command = `None`,
|  |  | fill = `X`,
|  |  | expand = `0`
| ) |  |

def createSlider | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = `None`,
|  |  | min = `0.0`,
|  |  | max = `1.0`,
|  |  | resolution = `None`,
|  |  | side = `TOP`,
|  |  | fill = `X`,
|  |  | expand = `1`,
|  |  | kw
| ) |  |

def createVector2Entry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = `None`,
|  |  | kw
| ) |  |

def createVector3Entry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = `None`,
|  |  | kw
| ) |  |

def cropCurve | ( |  | self | ) |

def curveEditTask | ( |  | self,
|  |  | state
| ) |  |

def desampleCurve | ( |  | self | ) |

def deselectedNodePathHook | ( |  | self,
|  |  | nodePath
| ) |  |

    Hook called upon deselection of a node path used to select playback
    marker if subnode selected

def disableKeyframeButton | ( |  | self | ) |

def easeInOut | ( |  | self,
|  |  | t
| ) |  |

def enableKeyframeButton | ( |  | self | ) |

def extractPointSetFromCurveCollection | ( |  | self | ) |

def extractPointSetFromCurveFitter | ( |  | self | ) |

def faceForward | ( |  | self | ) |

def followTerrain | ( |  | self,
|  |  | height = `1.0`
| ) |  |

def getChildIds | ( |  | self,
|  |  | nodePath
| ) |  |

def getPostPoints | ( |  | self | ) |

def getPrePoints | ( |  | self,
|  |  | type = `'Refine'`
| ) |  |

def getVariable | ( |  | self,
|  |  | category,
|  |  | text
| ) |  |

def getWidget | ( |  | self,
|  |  | category,
|  |  | text
| ) |  |

def initTrace | ( |  | self | ) |

def jumpToEndOfPlayback | ( |  | self | ) |

def jumpToStartOfPlayback | ( |  | self | ) |

def loadCurveFromFile | ( |  | self | ) |

def makeCameraWindow | ( |  | self | ) |

def makeEven | ( |  | self | ) |

def manipulateObjectCleanupHook | ( |  | self,
|  |  | nodePathList = `[]`
| ) |  |

def manipulateObjectStartHook | ( |  | self | ) |

def mergePoints | ( |  | self | ) |

def onDestroy | ( |  | self,
|  |  | event
| ) |  |

def playbackGoTo | ( |  | self,
|  |  | time
| ) |  |

def playbackTask | ( |  | self,
|  |  | state
| ) |  |

def pushRedo | ( |  | self | ) |

def pushRedoHook | ( |  | self | ) |

def pushUndo | ( |  | self,
|  |  | fResetRedo = `1`
| ) |  |

def pushUndoHook | ( |  | self | ) |

def recordPoint | ( |  | self,
|  |  | time
| ) |  |

def recordTask | ( |  | self,
|  |  | state
| ) |  |

def redoHook | ( |  | self,
|  |  | nodePathList = `[]`
| ) |  |

def redoListEmptyHook | ( |  | self | ) |

def reset | ( |  | self | ) |

def sampleCurve | ( |  | self,
|  |  | fCompute = `1`
| ) |  |

def saveCurveToFile | ( |  | self | ) |

def selectedNodePathHook | ( |  | self,
|  |  | nodePath
| ) |  |

    Hook called upon selection of a node path used to select playback
    marker if subnode selected

def selectNodePathNamed | ( |  | self,
|  |  | name
| ) |  |

def selectPointSetNamed | ( |  | self,
|  |  | name
| ) |  |

def setControlStart | ( |  | self,
|  |  | value
| ) |  |

def setControlStop | ( |  | self,
|  |  | value
| ) |  |

def setCropFrom | ( |  | self,
|  |  | value
| ) |  |

def setCropTo | ( |  | self,
|  |  | value
| ) |  |

def setCvColor | ( |  | self,
|  |  | color
| ) |  |

def setCvVis | ( |  | self | ) |

def setDesampleFrequency | ( |  | self,
|  |  | frequency
| ) |  |

def setExtendMode | ( |  | self | ) |

def setHullColor | ( |  | self,
|  |  | color
| ) |  |

def setHullVis | ( |  | self | ) |

def setKeyframeHook | ( |  | self,
|  |  | event = `None`
| ) |  |

def setKnotColor | ( |  | self,
|  |  | color
| ) |  |

def setKnotVis | ( |  | self | ) |

def setLoopPlayback | ( |  | self | ) |

def setMarkerVis | ( |  | self | ) |

def setNewCurveMode | ( |  | self | ) |

def setNodePath | ( |  | self,
|  |  | nodePath
| ) |  |

def setNumSamples | ( |  | self,
|  |  | numSamples
| ) |  |

def setNumSegs | ( |  | self,
|  |  | value
| ) |  |

def setNumTicks | ( |  | self,
|  |  | value
| ) |  |

def setPathColor | ( |  | self,
|  |  | color
| ) |  |

def setPathDuration | ( |  | self,
|  |  | event
| ) |  |

def setPathDurationTo | ( |  | self,
|  |  | newMaxT
| ) |  |

def setPathVis | ( |  | self | ) |

def setPlaybackNodePath | ( |  | self,
|  |  | nodePath
| ) |  |

def setPlaybackSF | ( |  | self,
|  |  | value
| ) |  |

def setPreRecordFunc | ( |  | self,
|  |  | func
| ) |  |

def setRecordingType | ( |  | self,
|  |  | type
| ) |  |

def setRecordStart | ( |  | self,
|  |  | value
| ) |  |

def setRefineMode | ( |  | self | ) |

def setRefineStop | ( |  | self,
|  |  | value
| ) |  |

def setSamplingMode | ( |  | self,
|  |  | mode
| ) |  |

def setSpeedScale | ( |  | self,
|  |  | value
| ) |  |

def setStartStopHook | ( |  | self,
|  |  | event = `None`
| ) |  |

def setTickColor | ( |  | self,
|  |  | color
| ) |  |

def setTickScale | ( |  | self,
|  |  | value
| ) |  |

def setTraceVis | ( |  | self | ) |

def startPlayback | ( |  | self | ) |

def startStopPlayback | ( |  | self | ) |

def stopPlayback | ( |  | self | ) |

def toggleRecord | ( |  | self | ) |

def toggleRecordVar | ( |  | self | ) |

def undoHook | ( |  | self,
|  |  | nodePathList = `[]`
| ) |  |

def undoListEmptyHook | ( |  | self | ) |

def updateWidgets | ( |  | self | ) |

## Member Data Documentation

actionEvents

string appname = 'Mopath Recorder Panel'`[static]`

cCam

cCamera

cCamNode

cDr

cLayer

cLens

controlStart

controlStop

int count = 0`[static]`

cropFrom

cropPage

cropTo

curveCollection

curveFitter

curveNodePath

deltaTime

desampleFrequency

drawPage

extendPage

fAdjustingValues

int frameHeight = 550`[static]`

int frameWidth = 450`[static]`

hasPoints

iRay

iRayCS

keyframeHook

lastPos

layerIndex

loopPlayback

mainNotebook

manipulandumId

maxT

name

nodePath

nodePathDict

nodePathMenu

nodePathMenuBG

nodePathMenuEntry

nodePathNames

nodePathParent

numSamples

numSegs

numTicks

nurbsCurveDrawer

oldPlaybackNodePath

optionsPage

playbackMarker

playbackMarkerIds

playbackNodePath

playbackSF

playbackTime

pointSet

pointSetCount

pointSetDict

pointSetName

postPoints

prePoints

preRecordFunc

OPTIONS PAGE ##.

recorderNodePath

recordingType

recordStart

recordStop

redoButton

refinePage

resamplePage

samplingMode

sf

RESAMPLE PAGE.

REFINE PAGE ## EXTEND PAGE ## CROP PAGE ## DRAW PAGE ##

speedEntry

speedScale

speedVar

startStopHook

tangentGroup

tangentLines

tangentMarker

tangentMarkerIds

tempCS

trace

undoButton

int usecommandarea = 0`[static]`

int usestatusarea = 0`[static]`

variableDict

widgetDict

All Classes Namespaces Functions Variables Enumerations Enumerator Properties